import { createSlice } from '@reduxjs/toolkit'
import {isEmpty} from "../utils/ObjectUtils";

/**
 *                 {
 *                     label: e.node.title,
 *                     children: e.node.key,
 *                     key: e.node.key,
 *                     activeKey:e.node.key
 *                 }
 */
export const tableBarItemSlice = createSlice({
    name: 'tableBarItem',
    initialState: {
        type:"tableBarItem",
        data: [],
        activeKey:""
    },
    reducers: {
        addTableBarItem: (state, action) => {
            console.log("tableBarItemSlice:tableBarItem", state, action,)
            if (state.data.filter(file=>file.key===action.payload.key).length===0){
                state.data.push(action.payload)
            }
            if (action.payload.activeKey){
                state.activeKey=action.payload.activeKey
            }
        },
        removeTableBarItem: (state, action) => {
            console.log("tableBarItemSlice:removeTableBarItem",action.payload)
            state.data=state.data.filter(file=>file.key!==action.payload)
            if (action.payload.activeKey){
                state.activeKey=action.payload.activeKey
            }
        },
        setActiveKey: (state, action) => {
            console.log("tableBarItemSlice:setActiveKey",action.payload)
            if (action.payload.activeKey){
                state.activeKey=action.payload.activeKey
            }
        },
        updatedSavedFile:(state, action)=>{
            console.log("tableBarItemSlice:updatedSavedFile",action.payload)
            // 如果其中包含了相同的key，则是文件覆盖。
            if (state.data.filter(file=>file.key===action.payload.filePath).length>0){
                state.data= state.data.filter(file=>file.key!==action.payload.filePath)
            }
            state.data.forEach(file=>{
                if (file.key===state.activeKey){
                    file.children=action.payload.filePath;
                    file.key = action.payload.filePath;
                    let split = action.payload.filePath.split("/");
                    console.log("action.payload.filePath.split()",split)
                    file.label =split[split.length-1]
                }
            })
            state.activeKey = action.payload.filePath
        }
    }
})
export const { addTableBarItem,
    removeTableBarItem,
    setActiveKey,
    updatedSavedFile} = tableBarItemSlice.actions
export default tableBarItemSlice.reducer
