const fs = window.require("fs").promises
const {ipcRenderer} = window.require('electron')

export async function readDir(filePath){
    const files = await fs.readdir(filePath);
    const fileStateList = []
    const fileChildList = []
    fileStateList.push({
        "fileName": filePath,
        "filePath": filePath,
        "dirFlag": true,
        "childList": fileChildList
    })
    for (let i = 0; i < files.length; i++) {
        const state = await fs.stat(filePath + '/' + files[i]);
        if (state.isDirectory()
            || files[i].endsWith(".md")
            || files[i].endsWith(".html")
            || files[i].endsWith(".lexical")) {
            fileChildList.push({
                'fileName': files[i],
                "filePath": filePath + '/' + files[i],
                'dirFlag': state.isDirectory(),
                "childList":[]
            })
        }
    }
    return fileStateList
}
export async function importFile(pathName) {
    return await fs.readFile(pathName)
}

export async function overWriteFile(filePath,jsonText) {
    await fs.writeFile(filePath,jsonText,{"encoding":"utf-8"})
}

export async function saveFileWithName(){
    return ipcRenderer.invoke("saveFileWithName" )
}